{{
MyCalc Version 2.1 by M.Sapp 2012_12_15

I wanted a way to exit out of the MyCalc program so I revised MyCalc 2

The program now displays the following 3 lines on start up.

    MY CALCUATOR Ver 2.1
    Function Keys are + - / * ^
    Q or q then Enter will Reboot System

You can now reboot your Propeller Chip by typing "Q" or "q" then the Enter key

I start via a Lauch Menu Program that loaded in my Propeller boards EEPROM.
Now I have a way to get back to the Launch Program Menu 

_________________________________________________________________________________________________________
 I found MyCalc 2 in this forum thread dated 04-07-2012, by CodeViper                         
 http://forums.parallax.com/showthread.php?139272-Improved-floating-point-calculator.-with-source-*fixed*
_________________________________________________________________________________________________________

______________________________________________________________________________________________
Below are comments I found in MyCalc 2 in the MyCalc 2 Parallax forum thread by  codeviper                                           
______________________________________________________________________________________________

An Improved floating point calculator

In using the prop as a real computer I needed a real calculator,
so i quickly took what was there and hacked together this one.

I improved it and now you cannot type over the 7 digit limit,
and i like the first number then second then answer format more.

To run this as is you need.
   * A PS2 keyboard on the pins the demoboard uses.
   * A NTSC TV with the DAC on the bins for the demoboard.
   * A working propeller.
 
______________________________________________________________________________________________
Below are the original comments I found in MyCalc 2 by  codeviper                                           
______________________________________________________________________________________________
 This is a combined effort.

 A post from before the forum migration featured a limited integer calculator.
 it worked well, yet most real math requires decimal places and division resulting in decimals
 put simply I needed floating point math.

 I hacked together  a similar parser and the float32 object
 and added support to block over typing digits longer then floatString2 could take
 Duane Degn fixed F32 and floatstring2 to support larger then 7 digit numbers,
 he also cleaned up my mistake when I left the power function as an integer function
 that is amazing and I am grateful for the help.

 It is my goal to make more native Apps and Games for the Propeller.
 I am just getting started on it, and not everything I have learned in making 8BIT SBCs and
 programming carries over but I hope my muddling will help someone.
_______________________________________________________________________________________________
}}

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  ESC    = $cb                 'I added this 

VAR
   byte num[40]
   byte input[40]
   long done
   long key
   long size
   long num1, num2
   long counter
   long answer
   long operator
   byte saf
   byte CL
   
OBJ

  Term  :       "TV_Text"
  F     :       "dwdF32"
  FS    :       "dwdFloatString2"
  keyboard :    "keyboard"

PUB Math
      
  F.start
  keyboard.start(26, 27)
  Term.Start(12)
       
  FS.SetPrecision(24)

  Term.Str(string("MY CALCUATOR Ver 2.1",13))                 ' I added this line
  Term.Str(string("Function Keys are + - / * ^",13))          ' I added this line
  Term.Str(string("Q or q then Enter will Reboot System",13)) ' I added this line
       
       
 repeat
    Term.Str(string("> ")) 
    'Get input
    CL := 7

    repeat counter from 0 to 40


      if(counter == 7 and saf ==0 ) 'wait for function keys
        repeat
           input[counter] := keyboard.getKey

          
           
         if(input[counter] == "-" or input[counter] == 47 or input[counter] == 43 or input[counter] == 42 or input[counter] == "q"or input[counter] == "Q") 'Enter key 'i added the "q" "Q"
           Term.Str(string("   "))
            quit 
      else
         input[counter] := keyboard.getKey  

      if(counter == 15 or counter ==8 + CL) 'wait for Enter key
        repeat
           input[counter] := keyboard.getKey
         if(input[counter] == 13) 'Enter key
            quit 

      if(input[counter] == 13) 'Enter key
        input[counter] := 0
        Term.Out(13) 
        quit

      if(input[counter] == "-" or input[counter] == 47 or input[counter] == 43 or input[counter] == 42 or input[counter] == "q"or input[counter] == "Q") 'Enter key  'i added the "q" "Q"
         Term.Out(13)
         saf :=1
         CL := counter 

      

            
      term.out(input[counter])  
   saf := 0
   
  'Parse first number
    repeat counter from 0 to 20
      if(input[counter] => "0" AND input[counter] =< "9" or input[counter] =="." ) 
        num[counter] := input[counter]
      else
        num[counter] := 0
        quit
    if(counter <> 0) 
      num1 := fs.StringToFloat(@num)
    else
      num1 := answer

    'Parse operator
    operator := input[counter]
    counter++

    bytemove(@input, @input+counter, 20)
    
    'Parse second number
    repeat counter from 0 to 20
      if(input[counter] => "0" AND input[counter] =< "9"or input[counter] ==".") 
        num[counter] := input[counter]
      else
        num[counter] := 0
        quit 
    num2 := fs.StringToFloat(@num)
 
    if operator == 42
      answer := F.FMUL(NUM1,NUM2)
    elseif operator == 47
      answer := F.FDIV(NUM1,NUM2) 
    elseif operator == 43
      answer := F.FADD(NUM1,NUM2) 
    elseif operator == "-"
      answer := F.FSUB(NUM1,NUM2) 
    elseif operator == "^"
      answer := F.Pow(NUM1,NUM2)

    elseif operator == "q"            'I added this
       reboot                         'I added this

    elseif operator == "Q"            'I added this
       reboot                         'I added this
      
    else
      answer := 0




  {Floating-point constants using FloatMath and FloatString objects}

  Term.Str(string("="))
  Term.Str(FS.FloatToString(answer))
  Term.Out(13) 
                                     